import smbus
import time
import subprocess
import os.path
from sys     import stderr
from logging import getLogger, StreamHandler, Formatter, DEBUG
import syslog

bus = smbus.SMBus(1)
address = 0x04
pin = ""

l  = getLogger()
sh = StreamHandler(stderr)
sh.setLevel(DEBUG)
f  = Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
sh.setFormatter(f)
l.addHandler(sh)
l.setLevel(DEBUG)
aPINS = {"123456" : "Silvia", "1234" : "Otto", "112233" : "Mama" }
def readtast():
	try:
	    tast = bus.read_byte_data(address, 1)
	    if (tast >= 48 and tast <= 57) or (tast >= 64 and tast <= 68):
                return tast
	except IOError:
    	    time.sleep(.001)

def sendi2c(apin):
	try:
            bus.write_byte(address, apin)
	except IOError:
            time.sleep(.001)

while True:
        tast = readtast() 
	if tast <> 0 and tast <> None:
            if chr(tast) == 'D':
               pin = ""
            else:
	       pin = pin + chr(tast)
        if pin in aPINS:
            lstring = 'Tuer geoeffnet, PIN von ' + aPINS[pin]
            syslog.syslog(syslog.LOG_INFO, lstring)
	    sendi2c(0x0A)
            pin = ""
        if os.path.exists("/tmp/tuerauf"):
           sendi2c(0x0A)
           lstring = "Tuer auf wegen file"
           os.remove("/tmp/tuerauf") 
